/* src/admin_chan.c - commandes admin pour gerer les salons
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "main.h"

void admin_chan(aNick *nick, aChan *chan, int parc, char **parv)
{
	char *c = NULL, *raison;
	const char *arg = parv[1];
	int i = 0, m = 0;

	if(parc > 1) chan = getchaninfo((c=parv[2]));

	if(!strcasecmp(arg, "suspend"))
	{
		if(parc < 2)
		{
			csntc(nick, "Syntaxe: %s SUSPEND <salon> [arg]", RealCmd("chan"));
			return;
		}
		if(!chan)
		{
			csntc(nick, NOSUCHAN, c);
			return;
		}
		if(parc < 3 && !IsSuspend(chan))
		{
			csntc(nick, "Veuillez prciser une raison pour suspendre ce salon.");
			return;
		}
		if(!IsSuspend(chan))
		{
			aLink *l, *lt;
			do_chan_suspend(chan, parv2msg(parc, parv, 3, 250), nick->user->nick, time(NULL));
			show_suspend(nick, chan);
			cspart(c, "%s", chan->suspend->raison);

			for(l=chan->members;l;l=lt)
			{
				lt = l->next;
				free(l);
				l = NULL;
			}
			chan->members = NULL;
			putlog(LOG_CHANS, "SUSPEND ON %s par %s@%s (%s)\n", c, nick->nick, nick->user->nick, chan->suspend->raison);
		}
		else
		{
			int nolog = getoption("-nolog", parv, parc, 2, -1);

			if(nolog)
			{
				free(chan->suspend);
				chan->suspend = NULL;
			}
			else chan->suspend->debut = -1 * chan->suspend->debut;

			csntc(nick, "Le salon \2%s\2 n'est plus suspendu.", c);
			csjoin(chan);
			csmode(chan, "+o %s", cs.num);
			csmode(chan, "%s", chan->defmodes);
			putlog(LOG_CHANS, "SUSPEND OFF %s par %s@%s\n", c, nick->nick, nick->user->nick);
		}
		write_achan(chan);
		return;
	}
	if(!strcasecmp(arg, "del"))
	{
		if(parc < 2)
		{
			csntc(nick, "Syntaxe: %s DEL <salon> <raison>", RealCmd("chan"));
			return;
		}
		if(!chan)
		{
			csntc(nick, NOSUCHAN, c);
			return;
		}
		raison = (parc > 2) ? parv2msg(parc, parv, 3, 300) : "Aucune raison";

		csntc(nick, "Le salon %s a bien t dsenregistr (%s)", c, raison);
		cspart(c, "Salon dsenregistr par %s -\2 %s", nick->nick, raison);
		cswallops("Le salon %s a t supprim par %s -\002 %s", c, nick->user->nick, raison);
		putlog(LOG_CHANS, "CHAN DEL %s par %s@%s (%s)\n", c, nick->nick, nick->user->nick, raison);

		del_chan(c);
		write_chanlist();
		return;
	}
	if(!strcasecmp(arg, "reg"))
	{
		anUser *u;
		int flag = 0;
		if(parc < 3)
		{
			csntc(nick, "Syntaxe: %s REG <salon> <Username> [description]", RealCmd("chan"));
			return;
		}
		if(chan)
		{
			csntc(nick, "%s est dj enregistr.", c);
			return;
		}
		if(!chan_check(c, nick)) return;
		if(!(u=getuserinfo(parv[3])))
		{
			csntc(nick, NOSUCHUSER, parv[3]);
			return;
		}

		raison = (parc >= 4) ? parv2msg(parc, parv, 4, 300) : "Adminreg";

		flag |= (A_OP | A_PROTECT);

		chan = add_chan(c, "", raison, "+nt", "", "", 0, 100, 1, "", "");
		add_access(u, c, 500, flag, time(NULL));
		csjoin(chan);
		csmode(chan, "+ont %s", cs.num);
		append_file(CHANS_FILE,c);
		write_achan(chan);
		write_anuser(u);
		csntc(nick, "%s a t enregistr pour %s.", c, parv[3]);
		return;
	}
	if(!strcasecmp(arg, "list"))
	{
		int description = getoption("-description", parv, parc, 2, 0);
		int modes = getoption("-modes", parv, parc, 2, 0);
		int defmodes = getoption("-defmodes", parv, parc, 2, 0);
		int url = getoption("-url", parv, parc, 2, 0), count = getoption("-count", parv, parc, 2, 1);
		int topic = getoption("-topic", parv, parc, 2, 0);
		csntc(nick, "\2\037Liste des salons enregistrs :");
		if(parc < 2 || *parv[2] == '-') m = 1;

		for(chan=chanhead;chan;chan=chan->next)
		{
			if((m || !match(parv[2], chan->chan))
			&& (!description || !match(parv[description], chan->description))
			&& (!modes || !match(parv[modes], GetCModes(chan)))
			&& (!defmodes || !match(parv[defmodes], chan->defmodes))
			&& (!url || !match(parv[url], chan->url))
			&& (!topic || !match(parv[topic], chan->topic))
			&& (++i <= count || !count))
				csntc(nick, "  %s (%s/%s) %s", chan->chan, chan->defmodes, GetCModes(chan), IsSuspend(chan) ? "(\2Supendu\2)" : "");
		}
		csntc(nick, "Il y a un total de \002%d\2 salon%s enregistr%s%s", i, i > 1 ? "s" : "", i > 1 ? "s" : "", !m ? " correspondants  la recherche." : ".");
		return;
	}
	if(!strcasecmp(arg, "suspendlist"))
	{
		int from = getoption("-from", parv, parc, 2, 0);
		csntc(nick, "\2\037Liste des salons suspendus :");
		if(parc < 2) m = 1;

		for(chan=chanhead;chan;chan=chan->next)
		{
			if(IsSuspend(chan)
				&& (m || !match(parv[2], chan->chan))
				&& (!from || !strcasecmp(parv[from], chan->suspend->from)))
			{
				csntc(nick, "  %s Par %s Depuis %s Raison: %s", chan->chan, chan->suspend->from, get_time(chan->suspend->debut), chan->suspend->raison);
				i++;
			}
		}
		csntc(nick, "Il y a un total de \002%d\2 salons suspendus correspondant  vos critres.", i);
		return;
	}
	if(!strcasecmp(arg, "join"))
	{
		if(parc < 2)
		{
			csntc(nick, "Syntaxe: %s JOIN <salon>", RealCmd("chan"));
			return;
		}
		if(!chan)
		{
			csntc(nick, NOSUCHAN, c);
			return;
		}
		if(IsSuspend(chan))
		{
			csntc(nick, "%s est actuellement suspendu pour %s, utilisez 'CHAN SUSPEND %s' pour lever le suspend.", c, chan->suspend->raison, c);
			return;
		}
		csjoin(chan);
		csmode(chan, "+o %s", cs.num);
		return;
	}
	if(!strcasecmp(arg, "part"))
	{
		aLink *l, *lt;
		if(parc < 2)
		{
			csntc(nick, "Syntaxe: %s PART <salon> [raison]", RealCmd("chan"));
			return;
		}
		if(!chan)
		{
			csntc(nick, NOSUCHAN, c);
			return;
		}
		raison = (parc > 2) ? parv2msg(parc, parv, 3, 300) : "Aucune Raison";

		cspart(c, "%s", raison);
		for(l=chan->members;l;l=lt)
		{
			lt = l->next;
			free(l);
			l = NULL;
		}
		chan->members = NULL;
		return;
	}
	if(!strcasecmp(arg, "newowner"))
	{
		anAccess *access, *new = NULL;
		anUser *user, *newu=NULL;
		int found = 0, flag = 0;

		if(parc <3)
		{
			csntc(nick, "Syntaxe: %s NEWOWNER  <chan> <nouvel owner>", RealCmd("chan"));
			return;
		}
		if(!chan)
		{
			csntc(nick, NOSUCHAN, c);
			return;
		}
		for(user = userhead;user;user = user->next)
		{
			if(!strcasecmp(user->nick, parv[3]))
			{
				new = GetAccessIbyUserI(user,c);
				newu=user;
				if(new && new->level == 500)
				{
					csntc(nick, "%s est dj l'owner de %s", parv[3], c);
					return;
				}
				found = 1;
			}
			else
			{
				if((access=GetAccessIbyUserI(user,c)) && access->level == 500)
				{
					csntc(nick, "Le salon %s possde dj un owner: %s", c, user->nick);
					csntc(nick, "Pour que %s ne soit plus owner et que %s le devienne, utilisez /%s CHAN CHOWNER %s %s %s", user->nick, parv[3], cs.nick, c, user->nick, parv[3]);
					return;
				}
			}
		}
		if(!found)
		{
			csntc(nick, NOSUCHUSER, parv[3]);
			return;
		}
		if(!new)
		{
			flag |= (A_OP | A_PROTECT);
			add_access(newu, c, 500, flag, time(NULL));
		}
		else new->level = 500;
		write_anuser(newu);
		csntc(nick, "%s est maintenant l'owner de %s", parv[3], c);
		return;
	}
	if(!strcasecmp(arg, "chowner"))
	{
		anAccess *old = NULL, *new = NULL;
		anUser *user,*newu=NULL,*lastu=NULL;
		int foundold = 0, foundnew = 0, flag = 0;;

		if(parc <4)
		{
			csntc(nick, "Syntaxe: %s CHOWNER  <chan> <owner actuel> <nouvel owner>", RealCmd("chan"));
			return;
		}
		if(!strcasecmp(parv[3],parv[4]))
		{
			csntc(nick, "Veuillez prciser un VRAI nouvel owner.");
			return;
		}
		if(!chan)
		{
			csntc(nick, NOSUCHAN, c);
			return;
		}
		for(user = userhead;user;user = user->next)
		{
			if(!strcasecmp(user->nick, parv[3]))
			{
				old = GetAccessIbyUserI(user,c);
				if(!old || old->level != 500)
				{
					csntc(nick, "%s n'est pas l'owner de %s", parv[3], c);
					return;
				}
				lastu=user;
					foundold++;
			}
			if(!strcasecmp(user->nick, parv[4]))
			{
				new = GetAccessIbyUserI(user,c);
				newu=user;
				if(new && new->level == 500)
				{
					csntc(nick, "%s est dj l'owner de %s", parv[4], c);
					return;
				}
				foundnew++;
			}
			if(foundnew && foundold) break;
		}
		if(!foundnew || !foundold)
		{
			if(!foundnew && !foundold) csntc(nick, "\2%s\2 et \2%s\2 ne sont pas des usernames existants.", parv[3], parv[4]);
			else csntc(nick, NOSUCHUSER, !foundnew ? parv[4] : parv[3]);
			return;
		}
		if(!new)
		{
			flag |= (A_OP | A_PROTECT);
			add_access(newu, c, 500, flag, time(NULL));
		}
		else new->level = 500;
		del_access(lastu, chan);
		write_anuser(lastu);
		write_anuser(newu);
		csntc(nick, "%s est maintenant l'owner de %s, et %s n'y a plus accs", parv[4], c, parv[3]);
		return;
	}
	csntc(nick, "%s n'est pas une option valide.", arg);
	return;
}

void whoison(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	int first=1, size = 0, usr = 0;
	char buf[400] = {0}, tmp[NICKLEN + 16];
	aLink *lp = NULL;

	for(lp=chaninfo->members;lp;lp=lp->next)
	{
		usr++;
		snprintf(tmp, (NICKLEN + 15), " %s%s", GetChanPrefix(lp->value.j->nick, lp->value.j, 1), lp->value.j->nick->nick);
		size += strlen(tmp);
		if(size >= 400)
		{
			strcat(buf, "...\0");
			if(first) csntc(nick, "Users sur %s:\2%s", chaninfo->chan, buf);
			else csntc(nick, "              :%s", buf);
			first = 0;
			strcpy(buf, tmp);
			size = strlen(tmp);
		}
		else strcat(buf, tmp);
	}
	strcat(buf, "\0");
	if(first && buf[0]!='\0') csntc(nick, "\002%d Users de %s:\2%s", usr, chaninfo->chan, buf);
	else if(buf[0]!='\0')
	{
		csntc(nick, "              :%s", buf);
		csntc(nick, " Un Total de %d Users sur %s", usr, chaninfo->chan);
	}

	return;
}

void rctopics(aNick *nick, aChan *chan, int parc, char **parv)
{
	for(chan=chanhead;chan;chan=chan->next) cstopic(chan, "%s", chan->topic);
	return;
}


void rdtopics(aNick *nick, aChan *chan, int parc, char **parv)
{
	for(chan=chanhead;chan;chan=chan->next) cstopic(chan, "%s", chan->deftopic);
	return;
}


void do_chan_suspend(aChan *chan, const char *raison, const char *nick, long int debut)
{
	if(!chan->suspend) chan->suspend = calloc(1, sizeof(struct suspendinfo));
	strncpy(chan->suspend->raison, raison, 250);
	strncpy(chan->suspend->from, nick, NICKLEN);
	chan->suspend->debut = debut;
	return;
}

void show_suspend(aNick *nick, aChan *chan)
{
	if(!chan->suspend) return; /* on aurait jamais du l'envoyer l*/
	csntc(nick, "Le salon %s %s suspendu par %s le %s", chan->chan, IsSuspend(chan) ? "est" : "n'est plus",\
	chan->suspend->from, get_time((chan->suspend->debut > 0) ? chan->suspend->debut : -1 * chan->suspend->debut));
	csntc(nick, "Raison: %s", chan->suspend->raison);
	return;
}
