/* src/showcommands.c - Liste les commandes
 * Copyright (C) 2002-2003 Inter System (Progs@Inter-System.Net)
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <main.h>

CVSINFO("$Id: showcommands.c,v 1.10 2003/04/10 18:55:21 romexzf Exp $");

extern struct cs_commands cs_cmds[];

void showcommands(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char cmd[5][400] = { {0}, {0}, {0}, {0}, {0} };
	anAccess *access;
	int level = 0, j = 0, maxlevel = 0, pr[5] = { 1, 1, 1, 1, 1};

	if(nick->user)
	{
		if(IsAnAdmin(nick->user)) maxlevel = 500;
		else for(access = nick->user->accesshead;access;access = access->next)
			if(maxlevel < access->level) maxlevel = access->level;
	}
	else maxlevel = 0;

	for(;cs_cmds[j].cmd[0] != '\0';j++)
	{
		int l = cs_cmds[j].level;

		if(cs_cmds[j].cmd[0] != CTCP_DELIM_CHAR && !(cs_cmds[j].flag & CMD_DISABLE)
			&& (!ChanCmd(j) || (AdmCmd(j) && nick->user && nick->user->level >= l)) && (!l || (nick->user && nick->user->level >= l)))
		{
			strcat(cmd[l], " ");
			strcat(cmd[l], cs_cmds[j].cmd);
		}
	}

	for(j = 0;j < 5; j++)
	{
		char tmp[100], *p = cmd[j];
		int i = 0;

		while(*p)
		{
			if(*p == ' ' && i > 80)
			{
				tmp[i] = '\0';
				if(pr[j])
				{
					if(j == 2) csntc(nick, "------------------[ \0036Commandes \2\0034Admins\3\2 ]------------------");
					else if(!j) csntc(nick, "------------------[ \0036Commandes \2\0033Users\3\2  ]------------------");
					csntc(nick, "\2Niveau %3d:\2%s", j, tmp);
					pr[j] = 0;
				}
				else csntc(nick, "          \2:\2 %s", tmp);
				i = 0;
			}
			else tmp[i++] = *p;
			p++;
		}

		if(i)
		{
			tmp[i] = '\0';
			if(pr[j])
			{
				if(j == 2) csntc(nick, "------------------[ \0036Commandes \2\0034Admins\3\2 ]------------------");
				else if(!j) csntc(nick, "------------------[ \0036Commandes \2\0033Users\3\2  ]------------------");
				csntc(nick, "\2Niveau %3d:\2%s", j, tmp);
			}
			else csntc(nick, "          \2:\2 %s", tmp);
		}
	}

	csntc(nick, "------------------[ \0036Commandes \2\0032Salons\3\2 ]------------------");
	for(; level<=500; level++)
	{
		if(level > maxlevel) break;
		if(!level || level <= maxlevel)
		{
			pr[0] = 1;
			cmd[0][0] = '\0';
			for(j = 0;cs_cmds[j].cmd[0] != '\0';j++)
			{
				if(ChanCmd(j) && cs_cmds[j].level == level && cs_cmds[j].cmd[0] != CTCP_DELIM_CHAR && !(cs_cmds[j].flag & CMD_DISABLE) && !AdmCmd(j))
				{
					strcat(cmd[0], " ");
					strcat(cmd[0], cs_cmds[j].cmd);
					if(strlen(cmd[0]) > 80)
					{
						if(pr[0])
						{
							pr[0] = 0;
							csntc(nick, "\2Niveau %3d:\2%s", level, cmd[0]);
						}
						else csntc(nick, "         \2:\2%s", cmd[0]);
						cmd[0][0] = '\0';
					}
				}
			}
			if(cmd[0][0] != '\0')
			{
				if(pr[0]) csntc(nick, "\2Niveau %3d:\2%s", level, cmd[0]);
				else csntc(nick, "          \2:\2%s", cmd[0]);
			}
		}
	}
	csntc(nick, "Pour de l'aide sur une commande tapez \037/%s %s <commande>\037", cs.nick, RealCmd("aide"));
	csntc(nick, "Vous pouvez demander plus d'informations sur \2%s", bot.chan);
	return;
}
