/* src/timers.c - fonctions de controle appelles periodiquement
 * Copyright (C) 2002-2003 Inter System (kouak@kouak.org)
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "main.h"
#include "time.h"

extern const int maxlastseen;
extern const int kill_interval;
extern struct killinfo *killhead;

void check_accounts()
{
	anAccess *access, *axx;
	anUser *user, *u2;
	int trouve = 0;
	time_t current = time(NULL);

	for(user=userhead;user;user=u2)
	{
		trouve=0;
		u2=user->next;
		if((user->lastseend + maxlastseen) < current && !IsAnAdmin(user) && !UNopurge(user)/* && user->suspendu <= 0*/)
		{
			cswallops("Purge de l'username %s (Lastseen %s)", user->nick, duration((current - user->lastseend)));
			trouve=1;
		}
		if((user->lastseend + REGISTER_TIMEOUT) < current && UFirst(user) && !trouve)
		{
			cswallops("Purge de l'username %s par register timeout", user->nick);
			trouve=1;
		}
		else if(user->n) user->lastseend=current;
		if(trouve)
		{
			for(access=user->accesshead;access;access=axx)
			{
				axx = access->next;
				if(access->level == 500)
				{
					cspart(access->chan, "Purge de l'username de l'owner (Lastseen %s)", duration((current - user->lastseend)));
					cswallops("%s dsenregistr par purge de l'username de l'owner %s", access->chan, user->nick);
					del_chan(access->chan);
				}
			}

			del_regnick(user);
		}
	}

	return;
}

#undef RAND_MAX
#define RAND_MAX 99999999
void check_kills()
{
	aKill *current, *next;
	aNick *nick = NULL;
	char buff[NICKLEN + 1];
	time_t ttm = time(NULL);

	if(!kill_interval) return;
	for(current = killhead;current;current=next)
	{
		next=current->next;
		if(ttm >= (current->timestamp + kill_interval) && (nick=getnickbynick(current->nick)))
		{
			if(!current->setkill && current->why == 2)
			{
				snprintf(buff, NICKLEN, "%s%02d", CHNICKRAND, rand());
				putserv("%s %s %s :%s\n", bot.servnum, TOKEN_SVSNICK, current->numeric, buff);
				del_killinfo(current->nick, current->numeric);
			}
			else
			{
				putserv("%s %s %s :%s (%s)\n", cs.num, TOKEN_KILL, current->numeric, cs.nick, (current->why == 1) ? "Pseudo illgal" : "Pseudo enregistr");
				del_killinfo(current->nick, current->numeric);
				del_nickinfo(nick);
			}
		}
	}
}

void check_bans()
{
	aChan *c;
	aBan *b,*b2;
	int have;
	c=chanhead;

	while(c)
	{
		if(!IsSuspend(c))
		{
			have=0;
			for(b=c->banhead;b;b=b2)
			{
				b2=b->next;
				if(b->fin && time(NULL) >= (b->debut + b->fin))
				{
					csmode(c, "-b %s", b->mask);
					del_ban(c, b->mask);
					have=1;
				}
			}
			if(have) write_bans(c);
		}
		c=c->next;
	}
	return;
}

extern const int maxlastseen;

void check_chans()
{
	aChan *chan, *nextchan;
	aLink *lp = NULL;
	int etat=0; /*1=pas d'owner, 2=pas d'access, 3=lastseend>maxlastseen*/
	time_t current = time(NULL);

	for(chan=chanhead;chan;chan=nextchan)
	{
		nextchan=chan->next;
		if(!chan->access) etat=2;
		else {
			etat=1;
			for(lp=chan->access;lp;lp=lp->next)
				if(lp->value.a->level == 500)
				{
					if(lp->value.a->lastseen > 1 && (lp->value.a->lastseen + maxlastseen) < current && !UNopurge(lp->value.a->user)) etat=3;
					else etat=0;
					break;
				}
		}
		if(etat)
		{
			if(etat==3 || CWantUnreg(chan))
			{
				char raison[300];

				if(etat==1) strcpy(raison, "Aucun owner");
				else if(etat==2) strcpy(raison, "Pas d'access");
				else if(etat==3) snprintf(raison, 300, "Pas de visite de l'owner depuis \2%s", get_time(lp->value.a->lastseen));
				cspart(chan->chan, "Suppression - %s", raison);
				cswallops("%s supprim - %s", chan->chan, raison);
				del_chan(chan->chan);
			}
			else
			{
				if(etat==1) cswallops("Le salon %s n'a pas d'owner. Si dans deux heure il n'en a pas retrouv un le salon sera supprim.", chan->chan);
				else if(etat==2) cswallops("Le salon %s n'a pas d'access. Le salon va tre supprim dans deux heures si il n'a pas t trait avant.", chan->chan);
				else continue;
				SetCWantUnreg(chan);
			}
		}
	}
}

